


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/uuid.py: 76%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/uuid.py</b> :
            <span class="pc_cov">76%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            39 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">31 run</span>
            <span class="mis shortkey_m button_toggle_mis">8 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">1 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="pln"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="pln"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="pln"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="stm run hide_run"><a href="#n14">14</a></p>
<p id="n15" class="stm run hide_run"><a href="#n15">15</a></p>
<p id="n16" class="stm run hide_run"><a href="#n16">16</a></p>
<p id="n17" class="pln"><a href="#n17">17</a></p>
<p id="n18" class="stm run hide_run"><a href="#n18">18</a></p>
<p id="n19" class="stm run hide_run"><a href="#n19">19</a></p>
<p id="n20" class="pln"><a href="#n20">20</a></p>
<p id="n21" class="stm run hide_run"><a href="#n21">21</a></p>
<p id="n22" class="pln"><a href="#n22">22</a></p>
<p id="n23" class="stm run hide_run"><a href="#n23">23</a></p>
<p id="n24" class="stm run hide_run"><a href="#n24">24</a></p>
<p id="n25" class="pln"><a href="#n25">25</a></p>
<p id="n26" class="stm run hide_run"><a href="#n26">26</a></p>
<p id="n27" class="stm run hide_run"><a href="#n27">27</a></p>
<p id="n28" class="stm run hide_run"><a href="#n28">28</a></p>
<p id="n29" class="stm run hide_run"><a href="#n29">29</a></p>
<p id="n30" class="pln"><a href="#n30">30</a></p>
<p id="n31" class="stm run hide_run"><a href="#n31">31</a></p>
<p id="n32" class="stm run hide_run"><a href="#n32">32</a></p>
<p id="n33" class="stm run hide_run"><a href="#n33">33</a></p>
<p id="n34" class="stm run hide_run"><a href="#n34">34</a></p>
<p id="n35" class="stm run hide_run"><a href="#n35">35</a></p>
<p id="n36" class="stm run hide_run"><a href="#n36">36</a></p>
<p id="n37" class="pln"><a href="#n37">37</a></p>
<p id="n38" class="stm run hide_run"><a href="#n38">38</a></p>
<p id="n39" class="stm run hide_run"><a href="#n39">39</a></p>
<p id="n40" class="stm run hide_run"><a href="#n40">40</a></p>
<p id="n41" class="pln"><a href="#n41">41</a></p>
<p id="n42" class="stm run hide_run"><a href="#n42">42</a></p>
<p id="n43" class="stm par run hide_run"><a href="#n43">43</a></p>
<p id="n44" class="stm mis"><a href="#n44">44</a></p>
<p id="n45" class="stm run hide_run"><a href="#n45">45</a></p>
<p id="n46" class="pln"><a href="#n46">46</a></p>
<p id="n47" class="stm run hide_run"><a href="#n47">47</a></p>
<p id="n48" class="stm run hide_run"><a href="#n48">48</a></p>
<p id="n49" class="stm run hide_run"><a href="#n49">49</a></p>
<p id="n50" class="stm run hide_run"><a href="#n50">50</a></p>
<p id="n51" class="stm run hide_run"><a href="#n51">51</a></p>
<p id="n52" class="pln"><a href="#n52">52</a></p>
<p id="n53" class="pln"><a href="#n53">53</a></p>
<p id="n54" class="pln"><a href="#n54">54</a></p>
<p id="n55" class="pln"><a href="#n55">55</a></p>
<p id="n56" class="pln"><a href="#n56">56</a></p>
<p id="n57" class="pln"><a href="#n57">57</a></p>
<p id="n58" class="pln"><a href="#n58">58</a></p>
<p id="n59" class="pln"><a href="#n59">59</a></p>
<p id="n60" class="pln"><a href="#n60">60</a></p>
<p id="n61" class="stm run hide_run"><a href="#n61">61</a></p>
<p id="n62" class="stm mis"><a href="#n62">62</a></p>
<p id="n63" class="stm mis"><a href="#n63">63</a></p>
<p id="n64" class="stm mis"><a href="#n64">64</a></p>
<p id="n65" class="stm mis"><a href="#n65">65</a></p>
<p id="n66" class="stm mis"><a href="#n66">66</a></p>
<p id="n67" class="pln"><a href="#n67">67</a></p>
<p id="n68" class="stm run hide_run"><a href="#n68">68</a></p>
<p id="n69" class="stm mis"><a href="#n69">69</a></p>
<p id="n70" class="stm mis"><a href="#n70">70</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># SECUREAUTH LABS. Copyright 2018 SecureAuth Corporation. All rights reserved.</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com"># This software is provided under under a slightly modified version</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># of the Apache Software License. See the accompanying LICENSE file</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># for more information.</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="pln"><span class="com"># Description:</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="com">#   Generate UUID compliant with http://www.webdav.org/specs/draft-leach-uuids-guids-01.txt.</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="pln"><span class="com">#   A different, much simpler (not necessarily better) algorithm is used.</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="pln"><span class="com"># Author:</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="com">#   Javier Kohen (jkohen)</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="stm run hide_run"><span class="key">from</span> <span class="nam">__future__</span> <span class="key">import</span> <span class="nam">absolute_import</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="stm run hide_run"><span class="key">from</span> <span class="nam">__future__</span> <span class="key">import</span> <span class="nam">print_function</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="stm run hide_run"><span class="key">import</span> <span class="nam">re</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t18" class="stm run hide_run"><span class="key">from</span> <span class="nam">random</span> <span class="key">import</span> <span class="nam">randrange</span><span class="strut">&nbsp;</span></p>
<p id="t19" class="stm run hide_run"><span class="key">from</span> <span class="nam">struct</span> <span class="key">import</span> <span class="nam">pack</span><span class="op">,</span> <span class="nam">unpack</span><span class="strut">&nbsp;</span></p>
<p id="t20" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t21" class="stm run hide_run"><span class="key">def</span> <span class="nam">generate</span><span class="op">(</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t22" class="pln">    <span class="com"># UHm... crappy Python has an maximum integer of 2**31-1.</span><span class="strut">&nbsp;</span></p>
<p id="t23" class="stm run hide_run">    <span class="nam">top</span> <span class="op">=</span> <span class="op">(</span><span class="num">1</span><span class="op">&lt;&lt;</span><span class="num">31</span><span class="op">)</span><span class="op">-</span><span class="num">1</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="stm run hide_run">    <span class="key">return</span> <span class="nam">pack</span><span class="op">(</span><span class="str">"IIII"</span><span class="op">,</span> <span class="nam">randrange</span><span class="op">(</span><span class="nam">top</span><span class="op">)</span><span class="op">,</span> <span class="nam">randrange</span><span class="op">(</span><span class="nam">top</span><span class="op">)</span><span class="op">,</span> <span class="nam">randrange</span><span class="op">(</span><span class="nam">top</span><span class="op">)</span><span class="op">,</span> <span class="nam">randrange</span><span class="op">(</span><span class="nam">top</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t25" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t26" class="stm run hide_run"><span class="key">def</span> <span class="nam">bin_to_string</span><span class="op">(</span><span class="nam">uuid</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="stm run hide_run">    <span class="nam">uuid1</span><span class="op">,</span> <span class="nam">uuid2</span><span class="op">,</span> <span class="nam">uuid3</span> <span class="op">=</span> <span class="nam">unpack</span><span class="op">(</span><span class="str">'&lt;LHH'</span><span class="op">,</span> <span class="nam">uuid</span><span class="op">[</span><span class="op">:</span><span class="num">8</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="stm run hide_run">    <span class="nam">uuid4</span><span class="op">,</span> <span class="nam">uuid5</span><span class="op">,</span> <span class="nam">uuid6</span> <span class="op">=</span> <span class="nam">unpack</span><span class="op">(</span><span class="str">'>HHL'</span><span class="op">,</span> <span class="nam">uuid</span><span class="op">[</span><span class="num">8</span><span class="op">:</span><span class="num">16</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="stm run hide_run">    <span class="key">return</span> <span class="str">'%08X-%04X-%04X-%04X-%04X%08X'</span> <span class="op">%</span> <span class="op">(</span><span class="nam">uuid1</span><span class="op">,</span> <span class="nam">uuid2</span><span class="op">,</span> <span class="nam">uuid3</span><span class="op">,</span> <span class="nam">uuid4</span><span class="op">,</span> <span class="nam">uuid5</span><span class="op">,</span> <span class="nam">uuid6</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t31" class="stm run hide_run"><span class="key">def</span> <span class="nam">string_to_bin</span><span class="op">(</span><span class="nam">uuid</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t32" class="stm run hide_run">    <span class="nam">matches</span> <span class="op">=</span> <span class="nam">re</span><span class="op">.</span><span class="nam">match</span><span class="op">(</span><span class="str">'([\dA-Fa-f]{8})-([\dA-Fa-f]{4})-([\dA-Fa-f]{4})-([\dA-Fa-f]{4})-([\dA-Fa-f]{4})([\dA-Fa-f]{8})'</span><span class="op">,</span> <span class="nam">uuid</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="stm run hide_run">    <span class="op">(</span><span class="nam">uuid1</span><span class="op">,</span> <span class="nam">uuid2</span><span class="op">,</span> <span class="nam">uuid3</span><span class="op">,</span> <span class="nam">uuid4</span><span class="op">,</span> <span class="nam">uuid5</span><span class="op">,</span> <span class="nam">uuid6</span><span class="op">)</span> <span class="op">=</span> <span class="op">[</span><span class="nam">int</span><span class="op">(</span><span class="nam">x</span><span class="op">,</span> <span class="num">16</span><span class="op">)</span> <span class="key">for</span> <span class="nam">x</span> <span class="key">in</span> <span class="nam">matches</span><span class="op">.</span><span class="nam">groups</span><span class="op">(</span><span class="op">)</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t34" class="stm run hide_run">    <span class="nam">uuid</span> <span class="op">=</span> <span class="nam">pack</span><span class="op">(</span><span class="str">'&lt;LHH'</span><span class="op">,</span> <span class="nam">uuid1</span><span class="op">,</span> <span class="nam">uuid2</span><span class="op">,</span> <span class="nam">uuid3</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="stm run hide_run">    <span class="nam">uuid</span> <span class="op">+=</span> <span class="nam">pack</span><span class="op">(</span><span class="str">'>HHL'</span><span class="op">,</span> <span class="nam">uuid4</span><span class="op">,</span> <span class="nam">uuid5</span><span class="op">,</span> <span class="nam">uuid6</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t36" class="stm run hide_run">    <span class="key">return</span> <span class="nam">uuid</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t38" class="stm run hide_run"><span class="key">def</span> <span class="nam">stringver_to_bin</span><span class="op">(</span><span class="nam">s</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t39" class="stm run hide_run">    <span class="op">(</span><span class="nam">maj</span><span class="op">,</span><span class="nam">min</span><span class="op">)</span> <span class="op">=</span> <span class="nam">s</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="str">'.'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm run hide_run">    <span class="key">return</span> <span class="nam">pack</span><span class="op">(</span><span class="str">'&lt;H'</span><span class="op">,</span><span class="nam">int</span><span class="op">(</span><span class="nam">maj</span><span class="op">)</span><span class="op">)</span> <span class="op">+</span> <span class="nam">pack</span><span class="op">(</span><span class="str">'&lt;H'</span><span class="op">,</span><span class="nam">int</span><span class="op">(</span><span class="nam">min</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t42" class="stm run hide_run"><span class="key">def</span> <span class="nam">uuidtup_to_bin</span><span class="op">(</span><span class="nam">tup</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="stm par run hide_run"><span class="annotate short">43&#x202F;&#x219B;&#x202F;44</span><span class="annotate long">line 43 didn't jump to line 44, because the condition on line 43 was never true</span>    <span class="key">if</span> <span class="nam">len</span><span class="op">(</span><span class="nam">tup</span><span class="op">)</span> <span class="op">!=</span> <span class="num">2</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t44" class="stm mis">        <span class="key">return</span><span class="strut">&nbsp;</span></p>
<p id="t45" class="stm run hide_run">    <span class="key">return</span> <span class="nam">string_to_bin</span><span class="op">(</span><span class="nam">tup</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="op">)</span> <span class="op">+</span> <span class="nam">stringver_to_bin</span><span class="op">(</span><span class="nam">tup</span><span class="op">[</span><span class="num">1</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t47" class="stm run hide_run"><span class="key">def</span> <span class="nam">bin_to_uuidtup</span><span class="op">(</span><span class="nam">bin</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t48" class="stm run hide_run">    <span class="key">assert</span> <span class="nam">len</span><span class="op">(</span><span class="nam">bin</span><span class="op">)</span> <span class="op">==</span> <span class="num">20</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="stm run hide_run">    <span class="nam">uuidstr</span> <span class="op">=</span> <span class="nam">bin_to_string</span><span class="op">(</span><span class="nam">bin</span><span class="op">[</span><span class="op">:</span><span class="num">16</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t50" class="stm run hide_run">    <span class="nam">maj</span><span class="op">,</span> <span class="nam">min</span> <span class="op">=</span> <span class="nam">unpack</span><span class="op">(</span><span class="str">"&lt;HH"</span><span class="op">,</span> <span class="nam">bin</span><span class="op">[</span><span class="num">16</span><span class="op">:</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t51" class="stm run hide_run">    <span class="key">return</span> <span class="nam">uuidstr</span><span class="op">,</span> <span class="str">"%d.%d"</span> <span class="op">%</span> <span class="op">(</span><span class="nam">maj</span><span class="op">,</span> <span class="nam">min</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t53" class="pln"><span class="com">#input: string</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="pln"><span class="com">#output: tuple (uuid,version) </span><span class="strut">&nbsp;</span></p>
<p id="t55" class="pln"><span class="com">#if version is not found in the input string "1.0"  is returned</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="pln"><span class="com">#example: </span><span class="strut">&nbsp;</span></p>
<p id="t57" class="pln"><span class="com">#           "00000000-0000-0000-0000-000000000000 3.0" returns ('00000000-0000-0000-0000-000000000000','3.0') </span><span class="strut">&nbsp;</span></p>
<p id="t58" class="pln"><span class="com">#           "10000000-2000-3000-4000-500000000000 version 3.0" returns ('00000000-0000-0000-0000-000000000000','3.0') </span><span class="strut">&nbsp;</span></p>
<p id="t59" class="pln"><span class="com">#           "10000000-2000-3000-4000-500000000000 v 3.0" returns ('00000000-0000-0000-0000-000000000000','3.0') </span><span class="strut">&nbsp;</span></p>
<p id="t60" class="pln"><span class="com">#           "10000000-2000-3000-4000-500000000000" returns ('00000000-0000-0000-0000-000000000000','1.0') </span><span class="strut">&nbsp;</span></p>
<p id="t61" class="stm run hide_run"><span class="key">def</span> <span class="nam">string_to_uuidtup</span><span class="op">(</span><span class="nam">s</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t62" class="stm mis">    <span class="nam">g</span> <span class="op">=</span>  <span class="nam">re</span><span class="op">.</span><span class="nam">search</span><span class="op">(</span><span class="str">"([A-Fa-f0-9]{8}-[A-Fa-f0-9]{4}-[A-Fa-f0-9]{4}-[A-Fa-f0-9]{4}-[A-Fa-f0-9]{12}).*?([0-9]{1,5}\.[0-9]{1,5})"</span><span class="op">,</span><span class="nam">s</span><span class="op">+</span><span class="str">" 1.0"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t63" class="stm mis">    <span class="key">if</span> <span class="nam">g</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="stm mis">        <span class="op">(</span><span class="nam">u</span><span class="op">,</span><span class="nam">v</span><span class="op">)</span> <span class="op">=</span> <span class="nam">g</span><span class="op">.</span><span class="nam">groups</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t65" class="stm mis">        <span class="key">return</span> <span class="op">(</span><span class="nam">u</span><span class="op">,</span><span class="nam">v</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="stm mis">    <span class="key">return</span><span class="strut">&nbsp;</span></p>
<p id="t67" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t68" class="stm run hide_run"><span class="key">def</span> <span class="nam">uuidtup_to_string</span><span class="op">(</span><span class="nam">tup</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="stm mis">    <span class="nam">uuid</span><span class="op">,</span> <span class="op">(</span><span class="nam">maj</span><span class="op">,</span> <span class="nam">min</span><span class="op">)</span> <span class="op">=</span> <span class="nam">tup</span><span class="strut">&nbsp;</span></p>
<p id="t70" class="stm mis">    <span class="key">return</span> <span class="str">"%s v%d.%d"</span> <span class="op">%</span> <span class="op">(</span><span class="nam">uuid</span><span class="op">,</span> <span class="nam">maj</span><span class="op">,</span> <span class="nam">min</span><span class="op">)</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
